//
//  FGAsciiView.m
//  Created by Francesco Germinara on 11/5/05.
//  Freeware 2005
//  www.germinara.it

//Subclass della classe NSTextView per visualizzare il testo in formato ASCII, solo i caratteri stampabili sono visualizzati

#import "FGAsciiView.h"
#import "FGHexTextView.h"


@implementation FGAsciiView

-(void)setSize:(int)nBytes{
  _dimbuffer=nBytes;
}

-(void) awakeFromNib{
   [self setSize:256];
 
   bufferdata=[[NSMutableData alloc] initWithLength:_dimbuffer];
   memset([bufferdata mutableBytes],'0',_dimbuffer);

   fntDati=[NSFont fontWithName:@"Courier"size:12.0];
   [self setFont:fntDati];
   [self setMenu:nil];
}

-(void)setTextToBuffer{
 _dimbuffer=[[self string] length]+1;
 [bufferdata release];
 bufferdata=[[NSMutableData alloc] initWithLength:_dimbuffer];
 memcpy([bufferdata mutableBytes],[[self string] cStringUsingEncoding:[NSString defaultCStringEncoding]],_dimbuffer);
}

- (void)mouseDown:(NSEvent *)theEvent{
 [super mouseDown:theEvent];
 [self setTextToBuffer];
 NSRange location=[self selectedRange];
  if(location.location >= _dimbuffer-1)
  location.location=_dimbuffer-1;
 [self updateData:location];
}

- (void)keyDown:(NSEvent *)theEvent
{
    NSString *strChar;
	strChar=[theEvent characters];
	
	int nChar=[strChar characterAtIndex:0];

    NSRange location=[self selectedRange];

	if(nChar==NSDeleteFunctionKey || nChar==NSDeleteCharFunctionKey || nChar==0x7F){
	 if(location.location < _dimbuffer){
	  //Se ho premuto cancella 
	  if(location.location>0){
	   location.location-=1;
	   ((unsigned char *)[bufferdata mutableBytes])[location.location] =0xFF;
	  }
	  [self updateData:location];
  	 }
	 return;  
	}	

	if(nChar==NSDownArrowFunctionKey){
     location.location+=16;
	 if(location.location >= _dimbuffer-1)
	  location.location=_dimbuffer-1;
	 [self updateData:location];
	 return;
	}
	
   if(nChar==NSUpArrowFunctionKey){
     if(location.location>16)
      location.location-=16;
	 else
	  location.location=0;
	 [self updateData:location];
	 return;
	}
	
   if(nChar==NSHomeFunctionKey){
	location.location=0;
	 [self updateData:location];
	 return;
	}

  if(nChar==NSEndFunctionKey){
	location.location=_dimbuffer-1;
	 [self updateData:location];
	 return;
	}

   if(nChar==NSPageUpFunctionKey){
    if(location.location > 1056)
	location.location-= 1056;
	else
	 location.location=0;
    [self updateData:location];
	return;
   }
   
   if(nChar==NSPageDownFunctionKey){
   location.location+= 1056;
    if(location.location >= _dimbuffer-1)
	 location.location=_dimbuffer-1;
	[self updateData:location];
	return;
   }
	
	//Tasti movimento cursore
	if(nChar==NSLeftArrowFunctionKey || nChar==NSRightArrowFunctionKey){
	 if((location.location >= _dimbuffer-1) && nChar==NSRightArrowFunctionKey)
	  return;
     [super keyDown:theEvent]; 
	 location=[self selectedRange];
     return;	
	}
 	
   //scrivo testo	 
   if(location.location < _dimbuffer){ //-1
	((unsigned char *)[bufferdata mutableBytes])[location.location] = nChar;
	location.location+=1;
    if(location.location >= _dimbuffer) //-1
	 location.location-=1;
   }
    
  //Sostituisco il testo
  [self updateData:location];
 }

//Aggiorno dati visualizzati leggendoli dal buffer
-(void)updateData:(NSRange) aRange{  
  [self setString:[NSString stringWithCString:[bufferdata mutableBytes] encoding:[NSString defaultCStringEncoding]]];	
  _dimbuffer=[[self string] length];
  //NSMutableParagraphStyle *style = [[NSParagraphStyle defaultParagraphStyle] mutableCopy];
  //[style setLineBreakMode:NSLineBreakByClipping]; 
  //[self setDefaultParagraphStyle:style];
  [self setSelectedRange:aRange];
  [self scrollRangeToVisible:aRange];
  [self updateHexView:aRange];
}

-(void)updateHexView:(NSRange) aRange{  
  aRange.location*=3;
  aRange.length*=3;
 [aHexView updateDataFromAscii:aRange withData:[bufferdata mutableBytes]];
}

 -(void)setHexView:( FGHexTextView *)theHexView{
  aHexView=theHexView;
 }
@end
