//
//  FGHexTextView.h
//  Created by Francesco Germinara on 11/5/05.
//  Freeware 2005
//  www.germinara.it

//Subclass della classe NSTextView per visualizzare il testo in formato ESADECIMALE

#import <Cocoa/Cocoa.h>

#import "FGAsciiView.h"

@interface FGHexTextView : NSTextView {
 long int _dimbuffer; //Dimensione del buffer dati allocato dinamicamente

 FGAsciiView *textDataView; //la finestra di visualizzazione in ASCII degli stessi dati
 
 IBOutlet NSTextField *offsetposition; //Indicatore dell'offset quando si clicca nella finestra
 NSFont *fntDati; //Il font usato
 
 IBOutlet NSMenu *aMenu; //Menu contestuale della finestra imposta la selezione o tutto a 00 oppure a FF
 
 NSMutableData *bufferdata;  //Il buffer con i dati, in realt  una stringa formata dai 2BYTES che rappresentano il carattare e da uno spazio
                             //Esempio il codice A viene rappresentato come "41 " ecc.
 
}
-(IBAction) menuSetFF:(id)sender; //Imposta tutti i bytes della selezione a FF o se non c'e' selezione TUTTO il buffer
-(IBAction) menuSet00:(id)sender; //Imposta tutti i bytes della selezione a 00 o se non c'e' selezione TUTTO il buffer

 -(void)setAsciiView:( FGAsciiView *)aDataView;  //Impostazione della finestra di visualizzazione ASCII
- (void)updateAsciiView:(NSRange) aRange; //Aggionrna la finestra ASCII
- (unsigned char) atoh:(NSString *)strValue; //Converte una stringa es. "41" in charattere ascii es. A
- (void)updateData:(NSRange) aRange; //Aggiorna la visualizzazione dati
- (void)updateDataFromAscii:(NSRange) aRange withData:(unsigned char*)bufferAscii; //Aggiorna il buffer dei dati leggendo i dati dal buffer ASCII
- (void)refresh:(unsigned char *) newbuffer withSize:(int)bytes; //Imposta un nuovo buffer con i dati e con la nuova dimensione
- (void)clear; //Ripulisce tutto il buffer dati (tutto a 00)
-(unsigned char*) getBufferData:(int*) lenBufffer; //Restituisce il buffer dei dati e la lunghezza in bytes
-(void)setSize:(int)nBytes; //Imposta la nuova lunghezza
-(void)setNewData:(NSData *)data; //Imposta i nuovi dati da un origine di tipo NSData (es. apertura di un file...)
-(void)setOffSetPositionIndicator:(NSTextField*) aTextField; //Imposta un elemento NSTextFied come oggetto da utilizzare per la visualizzazione della posizione di offset

@end


